# Connection Info Database

package provide cidb 1.0

namespace eval cidb {
	variable cidb
	variable isEnabled 1
	variable isInitialized 0
}

# initialize the array
proc cidb::initCI {args} {
	variable cidb
	variable isInitialized
	variable isEnabled
	if {!$isInitialized} {
		array unset cidb
		set cidb(isEnabled) $isEnabled
		set isInitialized 1
	}
}

# clears all saved key,prp,val triples
proc cidb::resetCI {{pwin .}} {
	variable cidb
	variable isEnabled
	cidb::initCI
	set isE $cidb(isEnabled)
	array unset cidb
	set cidb(isEnabled) $isE
		set msg "Saved Data has been cleared"
		tk_messageBox -type ok -default ok -parent $pwin -message $msg
}

# get/set enabled state of ci data
proc cidb::enabled {args} {
	variable cidb;
	cidb::initCI
	if {$args == ""} {
		return $cidb(isEnabled)
	} else {
		switch -regexp [lindex $args 0] {
		{^0$}                    { set v 0 }
		{^[fF]$}                 { set v 0 }
		{^[oO][fF][fF]$}         { set v 0 }
		{^[fF][aA][lL][sS][eE]$} { set v 0 }
		default                  { set v 1 }
		}
		return [set cidb(isEnabled) $v]
	}
}

# return T iff key|prp exists
proc cidb::existsCI {key prp} {
	variable cidb
	cidb::initCI
	return [info exists cidb($key|$prp)]
}

# return val of key,prp
proc cidb::getCI {key prp} {
	variable cidb
	cidb::initCI
	if {$cidb(isEnabled)} {
		if {[info exists cidb($key|$prp)]} {
			return $cidb($key|$prp)
		}
	}
	return ""
}

# add key,prp,val tuple
proc cidb::putCI {key prp val} {
	variable cidb
	cidb::initCI
	#if {$cidb(isEnabled)} {
	#	return [set cidb($key|$prp) $val]
	#}
	return [set cidb($key|$prp) $val]
}

# serialize the database
proc cidb::serialize {} {
	variable cidb
	cidb::initCI
	array get cidb
}

# unserialize the datatbase (restore it)
proc cidb::unserialize {cidblst} {
	variable cidb
	cidb::initCI
	array unset cidb
	array set cidb $cidblst
}

# vim:ts=4:sw=4:ai
